#ifndef MY_TARGET
#define MY_TARGET 

#include <stdlib.h>
#include <string.h>
#include<stdio.h>
#include<math.h>
#include<sys/types.h>		
#include<iostream.h>
#include<fstream.h>
#include<float.h>
#include<time.h>


#include "target_function.h"


class MyTarget : public Target{
	/*	This class implements abstract class Target. 
		Function loadDataSet() uses a simple quadratic fucntion to create a data set to learn.
	*/


public:

	MyTarget(int dataSetSize){
	  State::dimensionality=2;
	  DataSetSize = dataSetSize;
	  DataSet = new Sample[DataSetSize];
	  TrainingSet = new Sample[DataSetSize];
	  TestSet = new Sample[DataSetSize];
	}

	void loadDataSet(int argc, char* argv[]){

		int i;

		

		for (i=0; i< DataSetSize; i++){
			DataSet[i].input.x[0]=(double)rand()/((double)RAND_MAX);
			DataSet[i].input.x[1]=(double)rand()/((double)RAND_MAX);
			DataSet[i].target = (DataSet[i].input.x[0]-0.3)*(DataSet[i].input.x[0]-0.6)*DataSet[i].input.x[1];
			DataSet[i].taken = false;
		}
	}

	void formTrainingAndTestSets(int trainingSetSize, int testSetSize){
		int i, ind;


		if ((trainingSetSize < 0) || (testSetSize < 0) || ((trainingSetSize + testSetSize) > DataSetSize)){
			cout << "Error: wrong test and training set sizes." << endl;
			exit(EXIT_FAILURE);
		}

		TestSetSize=testSetSize;
		TrainingSetSize=trainingSetSize;

		//randomly select samples for the test set
		
		for (i=0; i<TestSetSize; i++){
			ind = rand() % DataSetSize;
			if (DataSet[ind].taken == false){
				TestSet[i]=DataSet[ind];
				DataSet[ind].taken=true;
			}
			else{
				do {
					if (ind < (DataSetSize-1)) ind++;
					else ind=0;
				}
				while (DataSet[ind].taken == true);

				TestSet[i]=DataSet[ind];
				DataSet[ind].taken=true;

			}
		}

		//form training set from untaken samples
		ind=0;
		i=0;
		while (ind < TrainingSetSize){
			if (DataSet[i].taken == false){
				TrainingSet[ind] = DataSet[i];
				ind++;
				i++;
			}
			else
				i++;
		}

		//clear all "taken" indicators in DataSet
		for (i=0; i<DataSetSize; i++)
			DataSet[i].taken = false;

	}

};

#endif
